<?php
/**
 * @package Zo2Framework for Joomla! 2.5
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2010- ZooTemplate.com
 * @license PHP files are GNU/GPL
**/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla view library
jimport('joomla.application.component.view');
 
/**
 * Feeds View
 */
class Zo2FrameworkViewConfig extends JView
{
	/**
	 * AutoContents view display method
	 * @return void
	 */
	function display($tpl = null) 
	{
		// Set the toolbar
		$this->addToolBar();
 		
		// get the Data
		$form   = $this->get('Form');
		$item   = $this->get('Item');
		
		// Set the submenu
		Zo2FrameworkHelper::addSubmenu('config');
		
		// Assign the Data
		$this->form   = $form;
		$this->item   = $item;
		// Display the template
		parent::display($tpl);
 
		// Set the document
		$this->setDocument();
	}
 
	/**
	 * Setting the toolbar
	 */
	protected function addToolBar() 
	{
		$canDo = Zo2FrameworkHelper::getActions();
		JToolBarHelper::title(JText::_('COM_ZO2FRAMEWORK_CONFIGURATION_TITLE'), 'cpanel');
		
		if($canDo->get('core.edit'))
		{
			// We can save the new record
			JToolBarHelper::apply('config.apply', 'COM_ZO2FRAMEWORK_CONFIGURATION_SAVE');
			JToolBarHelper::save('config.save', 'COM_ZO2FRAMEWORK_CONFIGURATION_SAVE_CLOSE');
		}
		
		JToolBarHelper::divider();
		JToolBarHelper::cancel('config.cancel', 'JTOOLBAR_CLOSE');
		
		if($canDo->get('core.admin')) 
		{
			JToolBarHelper::divider();
			JToolBarHelper::preferences('com_zo2framework');
		}
	}
	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument() 
	{
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_ZO2FRAMEWORK_ADMINISTRATION'));
	}
}
