<?php
/**
 * @package Zo2Framework for Joomla! 2.5
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2010- ZooTemplate.com
 * @license PHP files are GNU/GPL
**/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla view library
jimport('joomla.application.component.view');
 
/**
 * Feeds View
 */
class Zo2FrameworkViewHelp extends JView
{
	/**
	 * AutoContents view display method
	 * @return void
	 */
	function display($tpl = null) 
	{
		// Get data from the model
		$items 		= $this->get('Items');
		$pagination = $this->get('Pagination');
 		$state		= $this->get('State');
		
		// Check for errors.
		if(count($errors = $this->get('Errors'))) 
		{
			JError::raiseError(500, implode('<br />', $errors));
			return false;
		}
		
		// Assign data to the view
		$this->items 		= $items;
		$this->pagination 	= $pagination;
 		$this->state		= $state;
		
		// Set the toolbar
		$this->addToolBar();
 		
		// Set the submenu
		Zo2FrameworkHelper::addSubmenu('help');
		
		// Display the template
		parent::display($tpl);
 
		// Set the document
		$this->setDocument();
	}
 
	/**
	 * Setting the toolbar
	 */
	protected function addToolBar() 
	{
		$canDo = Zo2FrameworkHelper::getActions();
		JToolBarHelper::title(JText::_('COM_ZO2FRAMEWORK_HELP_TITLE'), 'help_header');
		
		if($canDo->get('core.admin')) {
			JToolBarHelper::divider();
			JToolBarHelper::preferences('com_zo2framework');
		}
	}
	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument() 
	{
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_ZO2FRAMEWORK_TEMPLATE_MANAGER'));
	}
}
