<?php
/**
 * @package Zo2Framework for Joomla! 2.5
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2010- ZooTemplate.com
 * @license PHP files are GNU/GPL
**/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla view library
jimport('joomla.application.component.view');
 
/**
 * Feed View
 */
class Zo2FrameworkViewTemplate extends JView
{
	/**
	 * display method of Hello view
	 * @return void
	 */
	public function display($tpl = null) 
	{
		// get the Data
		$form   = $this->get('Form');
		$item   = $this->get('Item');
		$script = $this->get('Script');
		
		// Check for errors.
		if(count($errors = $this->get('Errors'))) 
		{
			JError::raiseError(500, implode('<br />', $errors));
			return false;
		}
		
		// Assign the Data
		$this->form   = $form;
		$this->item   = $item;
		$this->script = $script;
		$this->assign = $assign;

		// Set the toolbar
		if($this->_layout != 'install') {
			$this->addToolBar();
		}
		else {
			$this->installToolBar();
		}
 
		// Display the template
		parent::display($tpl);
 
		// Set the document
		$this->setDocument();
	}
 
	/**
	 * Setting the toolbar
	 */
	protected function addToolBar() 
	{
		JRequest::setVar('hidemainmenu', true);
		$user = JFactory::getUser();
		$userId = $user->id;
		$canDo = Zo2FrameworkHelper::getActions($this->item->id);
		JToolBarHelper::title(JText::_('COM_ZO2FRAMEWORK_TEMPLATE_EDIT'), 'thememanager');
		// Built the actions for new and existing records.
		
		if($canDo->get('core.edit'))
		{
			// We can save the new record
			JToolBarHelper::save('template.save', 'JTOOLBAR_SAVE');
			JToolBarHelper::apply('template.apply', 'JTOOLBAR_APPLY');			
		}
		
		JToolBarHelper::cancel('template.cancel', 'JTOOLBAR_CLOSE');
	}
	
	/**
	 * Setting the install toolbar
	 */
	protected function installToolBar()
	{
		$user = JFactory::getUser();
		$userId = $user->id;
		$canDo = Zo2FrameworkHelper::getActions($this->item->id);
		JToolBarHelper::title(JText::_('COM_ZO2FRAMEWORK_TEMPLATE_INSTALL'), 'install');
		JToolBarHelper::back();
		
		// Set the submenu
		Zo2FrameworkHelper::addSubmenu('templates');
	}	
	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument() 
	{
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_ZO2FRAMEWORK_TEMPLATE_EDIT'));
	}
}
