/*
 * 	Easy Slider 1.7 - jQuery plugin
 *	written by Alen Grakalic	
 *	http://cssglobe.com/post/4004/easy-slider-15-the-easiest-jquery-plugin-for-sliding
 *
 *	Copyright (c) 2009 Alen Grakalic (http://cssglobe.com)
 *	Dual licensed under the MIT (MIT-LICENSE.txt)
 *	and GPL (GPL-LICENSE.txt) licenses.
 *
 *	Built for jQuery library
 *	http://jquery.com
 *
 */ 
 
(function($) {
	$.fn.easySlider = function(options){
		// default configuration properties
		var defaults = {			
			prevId: 		'prevBtn',
			prevText: 		'Previous',
			nextId: 		'nextBtn',	
			nextText: 		'Next',
			controlsShow:	true,
			controlsBefore:	'',
			controlsAfter:	'',	
			controlsFade:	true,
			firstId: 		'firstBtn',
			firstText: 		'First',
			firstShow:		false,
			lastId: 		'lastBtn',	
			lastText: 		'Last',
			lastShow:		false,				
			vertical:		false,
			speed: 			800,
			auto:			false,
			pause:			2000,
			continuous:		false, 
			numeric: 		false,
			numericId: 		'controls'
		}; 
		var options = $.extend(defaults, options);  
		this.each(function() {  
			var obj = $(this); 	 
			var s = $("li", obj).length;
			var w = obj.width();   
			var clickable = true; 
			obj.css("overflow","hidden");
			var ts = s-1;
			var t = 0; 
			$("ul", obj).css('width',s*w);		 
			if(options.continuous){
				$("ul", obj).prepend($("ul li:last-child", obj).clone().css("margin-left","-"+ w +"px"));
				$("ul", obj).append($("ul li:nth-child(2)", obj).clone());
				$("ul", obj).css('width',(s+1)*w);
			};				
			$("li", obj).css('width',w);
			var resize = function (){
				w = obj.width();  
				if(options.continuous){
					$("ul", obj).css('margin-left',-t*w);
				}
				$("ul", obj).css('width',(s+1)*w);
				$("li", obj).css({'width':w});  
				$("li:first", obj).css({'margin-left': -(w)}); 
			}
			$(window).load(function(){
				$(obj).css('display','block');
				$(obj).animate({'opacity': '1'}, 500);
				resize();
			}); 
			$(window).bind("resize", function () {
				resize();
			});
			if(!options.vertical) $("li", obj).css('float','left'); 
			if(options.controlsShow){
				var html = options.controlsBefore;
				html += '<div class="slidepagenav">';
				if(options.numeric){
					html += '<ol id="'+ options.numericId +'"></ol>';
				} else {
					if(options.firstShow) html += '<span class="prev first" id="'+ options.firstId +'"><a href=\"javascript:void(0);\">'+ options.firstText +'</a></span>';
					html += ' <span class="prev" id="'+ options.prevId +'"><a href=\"javascript:void(0);\">'+ options.prevText +'</a></span>';
					html += ' <span class="next" id="'+ options.nextId +'"><a href=\"javascript:void(0);\">'+ options.nextText +'</a></span>';
					if(options.lastShow) html += ' <span class="prev last" id="'+ options.lastId +'"><a href=\"javascript:void(0);\">'+ options.lastText +'</a></span>';				
				};
				html += '</div>';
				html += options.controlsAfter;						
				$(obj).append(html); 
			};
			if(options.numeric){									
				for(var i=0;i<s;i++){						
					$(document.createElement("li"))
						.attr('id',options.numericId + (i+1))
						.html('<a rel='+ i +' href=\"javascript:void(0);\">'+ (i+1) +'</a>')
						.appendTo($("#"+ options.numericId))
						.click(function(){							
							animate($("a",$(this)).attr('rel'),true);
						}); 												
				};							
			} else {
				$("a","#"+options.nextId).click(function(){		
					animate("next",true);
				});
				$("a","#"+options.prevId).click(function(){		
					animate("prev",true);				
				});	
				$("a","#"+options.firstId).click(function(){		
					animate("first",true);
				});				
				$("a","#"+options.lastId).click(function(){		
					animate("last",true);				
				});				
			}; 
			function setCurrent(i){
				i = parseInt(i)+1; 
				$("li", "#" + options.numericId).removeClass("current");
				$("li#" + options.numericId + i).addClass("current");
			};
			function adjust(){
				if(t>ts) t=0;		
				if(t<0) t=ts;	
				if(!options.vertical) {
					$("ul",obj).css("margin-left",(t*w*-1));
				} else {
					$("ul",obj).css("margin-left",(t*h*-1));
				}
				clickable = true;
				if(options.numeric) setCurrent(t);
				var sliderCaption = $('.slider-caption',obj);
				sliderCaption.find('h2').stop().animate({left:0, opacity:1}, 0, function(){
					setTimeout(function(){
						sliderCaption.find('h2').stop().animate({left:-40, opacity: 0}, 500);
					}, 100); 
				});  
				sliderCaption.find('p').stop().animate({left:0, opacity:1}, 0, function(){ 
					setTimeout(function(){
						sliderCaption.find('p').stop().animate({left:40, opacity: 0}, 500);
					}, 400);
				}); 
				setTimeout(function(){
					processCaption(t);
				}, 600); 
			};
			$(obj).append('<div class="slider-caption hidden-phone"></div>');
			$('.slider-caption', $(obj)).css('opacity', 0);
			function processCaption(i){
				i = parseInt(i)+1;
				var sliderCaption = $('.slider-caption',obj);
				var kids = obj.find('img');
				var currentImage = $(kids[i]);
				var title = currentImage.attr('data-caption')
				if(title.substr(0,1) == '#') title = $(title).html(); 
				sliderCaption.html(title);
				var widthtitle = sliderCaption.find('h2').width(); 
				var widthdec = sliderCaption.find('p').width();
				sliderCaption.find('h2').stop().animate({left:-40, opacity:0}, 0, function(){
					setTimeout(function(){
						sliderCaption.find('h2').stop().animate({left:0, opacity: 1}, 500);
					}, 100); 
				});  
				sliderCaption.find('p').stop().animate({left:40, opacity:0}, 0, function(){ 
					setTimeout(function(){
						sliderCaption.find('p').stop().animate({left:0, opacity: 1}, 500);
					}, 500);
				}); 
			} 
			function animate(dir,clicked){
				if (clickable){
					clickable = false;
					var ot = t; 
					switch(dir){
						case "next":
							t = (ot>=ts) ? (options.continuous ? t+1 : ts) : t+1;						
							break; 
						case "prev":
							t = (t<=0) ? (options.continuous ? t-1 : 0) : t-1;
							break; 
						case "first":
							t = 0;
							break; 
						case "last":
							t = ts;
							break; 
						default:
							t = dir;
							break; 
					};
					
					var diff = Math.abs(ot-t);
					var speed = diff*options.speed;						
					if(!options.vertical) {
						p = (t*w*-1); 
						$("ul",obj).animate(
							{ marginLeft: p }, 
							{ queue:false, duration:speed, complete:adjust }
						);				
					} else {
						p = (t*h*-1); 
						$("ul",obj).animate(
							{ marginTop: p }, 
							{ queue:false, duration:speed, complete:adjust }
						);					
					}; 
					if(!options.continuous && options.controlsFade){					
						if(t==ts){
							$("a","#"+options.nextId).hide();
							$("a","#"+options.lastId).hide();
						} else {
							$("a","#"+options.nextId).show();
							$("a","#"+options.lastId).show();					
						};
						if(t==0){
							$("a","#"+options.prevId).hide();
							$("a","#"+options.firstId).hide();
						} else {
							$("a","#"+options.prevId).show();
							$("a","#"+options.firstId).show();
						};					
					}; 
					if(clicked) clearTimeout(timeout); 
					if(options.auto && dir=="next" && !clicked){;
						timeout = setTimeout(function(){
							animate("next",false);
						},diff*options.speed+options.pause);
					};
				};
			};
			// init
			var timeout;
			if(options.auto){;
				timeout = setTimeout(function(){
					animate("next",false);
				},options.pause);
				$(obj).hover(function(){ 
					clearTimeout(timeout);
				},function(){
					if(options.auto){
						timeout = setTimeout(function(){
							animate("next",false);
						},options.pause);
					} 
				});
			};		 
			if(options.numeric) setCurrent(0);
			processCaption(0);
			if(!options.continuous && options.controlsFade){					
				$("a","#"+options.prevId).hide();
				$("a","#"+options.firstId).hide();				
			};	
		});
	};
})(jQuery); 