<?php
/**
 * @package Zo2Framework for Joomla! 2.5
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2010- ZooTemplate.com
 * @license PHP files are GNU/GPL
**/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla modelform library
jimport('joomla.application.component.modeladmin');
jimport('joomla.html.parameter');
/**
 * Feed Model
 */
class Zo2FrameworkModelConfig extends JModelAdmin
{
	var $db			= NULL;
	
	public function __construct($config = array())
	{
		parent::__construct($config);
		
		$this->db			= &JFactory::getDBO();
	}
				
	
	protected function allowEdit($data = array(), $key = 'id')
	{
		// Check specific edit permission then general edit permission.
		return JFactory::getUser()->authorise('core.edit', 'com_zo2framework.message.'.((int) isset($data[$key]) ? $data[$key] : 0)) or parent::allowEdit($data, $key);
	}


	public function getTable($type = 'Config', $prefix = 'Zo2FrameworkTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	
	
	public function getForm($data = array(), $loadData = true) 
	{
		// Get the form.
		$form = $this->loadForm('com_zo2framework.config', 'config', array('control' => 'jform', 'load_data' => $loadData));
		if(empty($form)) {
			return false;
		}
		return $form;
	}
	
	
	protected function loadFormData() 
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_zo2framework.edit.config.data', array());
		if(empty($data)) {
			$data = $this->getItem();
		}
		foreach($data->params as $k=>$v) {
			$data->$k = $v;
		}
		return $data;
	}	
	
	
	public function save()
	{
		global $app;
		
		$post 	= JRequest::getVar('jform');
		$id	  	= $post['id'];
		$params	= "";
		
		// Remove unused variable
		unset($post['id']);
		
		// Bind params
		$txt = array();
		foreach($post as $k => $v) {
			if(is_array($v)){
				$v 		= (count($v)) ? '["' . implode('","', $v) . '"]' : '[]';
				$txt[] 	= '"'.$k.'":' . $v;
			}
			else {
				$txt[] = '"'.$k.'":"' . $v . '"';
			}
		}
		$params = "{" . implode(",", $txt) . "}";
		
		// Store data
		parent::save(array('id'=>$id, 'params'=>$params));
		
		// Set message
		$app->setUserState('com_zo2framework.message', JTEXT::_('COM_ZO2FRAMEWORK_SAVE_CONFIG_SUCCESS'));
		
		return true;
	}
}