<?php
/**
 * @package Zo2Framework for Joomla! 2.5
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2010- ZooTemplate.com
 * @license PHP files are GNU/GPL
**/

// Ensure this file is being included by a parent file
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

/**
 * Radio List Element
 *
 * @since      Class available since Release 1.2.0
 */
class JFormFieldComponents extends JFormField
{
	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	protected $type 	= 'Components';
	protected $_options = array();
	protected $_type;

	function getInput()
	{		
		$path 		= JPATH_ROOT.DS.'components';
		$rows 		= $this->loadAllFolder($path);
		$groupHTML  = array();
		
		if(count($rows))
		for($i = 0; $i < count($rows); $i++)
		{
			$id 	= $rows[$i]['id'];
			$parent = $rows[$i]['parent'];
			$dname	= $rows[$i]['name'];
			$view	= $rows[$i]['fullname'].DS.'views';
			
			if(!$parent)
			{								
				$groupHTML[] = JHTML::_('select.option', $dname, $dname);
				
				if(is_dir($view))
				{
					$views = $this->loadAllFolder($view);
					if(count($views))
					{
						for($k = 0; $k < count($views); $k++)
						{
							$parent = $views[$k]['parent'];
							$dname	= $views[$k]['name'];
							if(!$parent)
							{								
								$groupHTML[] = JHTML::_('select.option', $rows[$i]['name'].'.'.$dname, "|---- " . $dname);
							}
						}
					}
				}
			}
		}
		
		$lists = JHTML::_('select.genericlist', $groupHTML, "{$this->name}[]", ' multiple="multiple" class="multi_select"', 'value', 'text', $this->value);
		return $lists;
	}
	
	function loadAllFolder($path)
	{
		$folders = JFolder::listFolderTree($path, '');
		return $folders;
	}
}