<?php
/**
 * @package Zo2Framework for Joomla! 2.5
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2010- ZooTemplate.com
 * @license PHP files are GNU/GPL
**/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
// import the Joomla modellist library
jimport('joomla.application.component.modellist');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');
jimport('joomla.utilities.simplexml');
/**
 * FeedList Model
 */
class Zo2frameworkModelUpdates  extends JModelList
{
	var $extensions = NULL;
	var $db			= NULL;
	var $updates	= array();
	var $xserver	= NULL;
	var $xfile		= NULL;
	
	public function __construct($config = array())
	{
		parent::__construct($config);
		
		$this->xfile 	= JPATH_ROOT . DS . "administrator" . DS . "components" . DS . "com_zo2framework" . DS . "extensions.xml";
		$this->xserver	= "http://zo2.zoodemo.com/updates/extensions.xml";
		
		$this->db	= JFactory::getDBO();
		
		$xml = new JSimpleXML;
		$xml->loadFile($this->xfile);
		
		$this->extensions = $xml->document->_children;
		$this->checkUpdates();
	}
	
	
	function find()
	{
		$app 	= JFactory::getApplication();
		$buffer = JFile::read($this->xserver);
		
		if(!strlen($buffer)) {
			$app->setUserState('com_zo2framework.message', JTEXT::_('COM_ZO2FRAMEWORK_UPDATES_CANT_LOAD_FILE'));
			return false;
		}
		
		JFile::write($this->xfile, $buffer);
		
		$app->setUserState('com_zo2framework.message', JTEXT::_('COM_ZO2FRAMEWORK_UPDATES_LOAD_FILE_SUCCESS'));
		return true;
	}
	
	
	function checkUpdates()
	{
		// Remove all old record
		$query = "TRUNCATE TABLE #__zof_extensions";
		$this->db->setQuery($query);
		$this->db->query();
		
		// Check new extensions
		if(count($this->extensions))
		for($i = 0; $i < count($this->extensions); $i++)
		{
			$extension = $this->extensions[$i]->_attributes;
			
			$name	   		= $extension['name'];
			$element		= $extension['element'];
			$type			= $extension['type'];
			$version		= $extension['version'];
			$cversion		= str_replace(".", "", $extension['version']);
			$downloadurl	= $extension['downloadurl'];
			
			if($this->checkVersion($element, $type, $cversion)) {
				$query = "INSERT INTO #__zof_extensions VALUES ('', '$name', '$element', '$type', '$version', '$downloadurl')";
				$this->db->setQuery($query);
				$this->db->query();
			}
		}
		
		return true;
	}
	
	
	function checkVersion($element, $type, $version)
	{
		$query = "SELECT manifest_cache FROM #__extensions WHERE type = '$type' AND element = '$element'";
		$this->db->setQuery($query);
		
		if($this->db->loadResult()) {
			$params = new JParameter();
			$params->bind($this->db->loadResult());
			
			$oversion = str_replace(".", "", $params->get('version'));
			
			if($oversion < $version) {
				return true;
			}
		}
		
		return false;
	}
	
	
	function updates()
	{
		$ids = JRequest::getVar('cid');
		$app = JFactory::getApplication();
		
		if(count($ids))
		for($i = 0; $i < count($ids); $i++) {
			$query = "SELECT downloadurl FROM #__zof_extensions WHERE id = " . $ids[$i];
			$this->db->setQuery($query);
			$url   = $this->db->loadResult();
			
			if(!$url) {
				$app->setUserState('com_zo2framework.message', JTEXT::_('COM_ZO2FRAMEWORK_UPDATES_NOT_URL'));
				return false;
			}
			
			$package = $this->_getPackageFromUrl($url);
			
			$this->install($package);
		}
		
		return true;
	}
	
	
	function install($package)
	{
		$app = JFactory::getApplication();
		
		// Was the package unpacked?
		if(!$package) {
			$app->setUserState('com_zo2framework.message', JText::_('COM_ZO2FRAMEWORK_UPDATES_UNABLE_TO_FIND_INSTALL_PACKAGE'));
			return false;
		}
		
		// Get an installer instance
		$installer = JInstaller::getInstance();
		
		// Install the package
		if(!$installer->install($package['dir'])) {
			// There was an error installing the package
			$msg = JTEXT::_('COM_ZO2FRAMEWORK_UPDATES_INSTALL_ERROR');
			$result = false;
		}
		else {
			// Package installed sucessfully
			$msg = JTEXT::_('COM_ZO2FRAMEWORK_UPDATES_INSTALL_SUCCESS');
			$result = true;
		}

		// Set some model state values
		$app->setUserState('com_zo2framework.message', $msg);

		// Cleanup the install files
		if(!is_file($package['packagefile'])) {
			$config = JFactory::getConfig();
			$package['packagefile'] = $config->get('tmp_path') . '/' . $package['packagefile'];
		}

		JInstallerHelper::cleanupInstall($package['packagefile'], $package['extractdir']);

		return $result;
	}
	
	
	function _getPackageFromUrl($url)
	{
		$p_file = JInstallerHelper::downloadPackage($url);

		// Was the package downloaded?
		if(!$p_file) {
			JError::raiseWarning('', JText::_('COM_ZO2FRAMEWORK_UPDATES_INVALID_URL'));
			return false;
		}

		$config		= JFactory::getConfig();
		$tmp_dest	= $config->get('tmp_path');

		// Unpack the downloaded package file
		$package = JInstallerHelper::unpack($tmp_dest . '/' . $p_file);

		return $package;
	}
	
	
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');
		
		// Load the filter search.
		$search = $this->getUserStateFromRequest($this->context.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);
		
		// List state information.
		parent::populateState('id', 'ASC');
	}
	
	
	protected function getListQuery()
	{
		// Create a new query object.		
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		// Select some fields
		$query->select('*');
		// From the hello table
		$query->from('#__zof_extensions');
		
		if($this->getState('filter.search') !== '')
		{
			$token = $db->Quote('%'.$db->escape($this->getState('filter.search')).'%');
			
			// Compile the different search clauses.
			$searches	= array();
			$searches[]	= 'name  LIKE ' . $token;
			$searches[]	= 'element  LIKE ' . $token;
			$searches[]	= 'type  LIKE ' . $token;
			$searches[]	= 'version  LIKE ' . $token;

			// Add the clauses to the query.
			$query->where('('.implode(' OR ', $searches).')');
		}
		
		return $query;
	}
}