<?php
/*
# ------------------------------------------------------------------------
# ZO2 Framework plugin for Joomla 2.5
# ------------------------------------------------------------------------
# Copyright(C) 2008-2012 www.zootemplate.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: ZooTemplate
# Websites: http://www.zootemplate.com
# ------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import library dependencies
jimport('joomla.plugin.plugin');
jimport('joomla.html.parameter');

// Require Google Lib
require_once dirname(__FILE__).'/libs/googleMaps.lib.php';

class plgContentZO2Framework extends JPlugin
{
	var $params = NULL;
	var $db		= NULL;
	var $com	= NULL;
	var $view   = NULL;
	var $layout = NULL;
	var $base   = NULL;
	var $thumb  = NULL;


	public function plgContentZO2Framework(&$subject, $config)
    {
		parent::__construct($subject, $config);
		
		// Get params
		$this->db 	= &JFactory::getDBO();
		$query 		= "SELECT params FROM #__zof_config WHERE `id` = 1";
		$this->db->setQuery($query);
		$params = $this->db->loadResult();
		
		$this->params = new JParameter();
		$this->params->bind($params);
		
		$this->com 		= JRequest::getCmd('option');
		$this->view		= JRequest::getCmd('view');
		$this->layout	= JRequest::getCmd('layout');
		$this->base		= JURI::base();
		$this->thumb	= $this->base . "components/com_zo2framework/includes/timthumb.php";
    }
	
	/* ZO2 Resize Images */
	public function checkBeforeResize()
	{
		$enable = $this->params->get('thumb_enable');
	
		switch ($enable) {
			case "content":
				return ("com_content" == $this->com);
			case "k2":
				return ("com_k2" == $this->com);
			case "both":
				return true;
			default:
				return false;
		}
	}
	
	
	public function resizeAllImages($text, $title, $w, $h, $q, $a, $z)
	{
		$regex_img = "#<img(.*?)src=\"(.*?)\"(.*?)>#si";
		preg_match_all($regex_img, $text, $matches_img);
		
		if(!count($matches_img[2])) return $text;
		
		for($i = 0; $i < count($matches_img[2]); $i++) {
			if(strpos("http://", $matches_img[2][$i]) === FALSE) {
				$image = $this->base . $matches_img[2][$i];
			}
			else {
				$image = $matches_img[2][$i];
			}
			$thumb 	   = $this->thumb . "?src=" . $image . "&w=" . $w . "&h=" . $h . "&a=" . $a . "&q=" . $q . "&z=" . $z;
			$new_image = '<span class="itemthumb-image"><img src="'.$thumb.'" title="'.$title.'" alt="'.$title.'" /></span>';
			
			$text = str_replace($matches_img[0][$i], $new_image, $text);			
		}
		
		return $text;		
	}
	
	
	public function getImage($text, $title, $w, $h, $q, $a, $z)
	{
		$image	   = "";
		$regex_img = "#<img(.*?)src=\"(.*?)\"(.*?)>#si";
		preg_match($regex_img, $text, $matches_img);
		
		if(!count($matches_img)) return;
		
		if(strpos("http://", $matches_img[2]) === FALSE) {
			$image = $this->base . $matches_img[2];
		}
		else {
			$image = $matches_img[2];
		}
		
		$thum = $this->thumb . "?src=" . $image . "&amp;w=" . $w . "&amp;h=" . $h . "&amp;a=" . $a . "&amp;q=" . $q . "&amp;z=" . $z;
		$text = '<span class="blogthumb-image"><img src="'.$thum.'" title="'.$title.'" alt="'.$title.'" /></span>';
		
		return $text;
	}
	
	
	public function onContentBeforeDisplay($context, &$article, &$params, $page = 0)
	{
		$check = $this->checkBeforeResize();
		
		if(!$check) {
			return false;
		}
		
		if($this->com == 'com_content' && ($this->view == 'category' || $this->view == 'featured')) {
			$text  = $this->getArticleDetail($article->id);
			$title = $article->title;
			
			$w = $this->params->get('thumb_width');
			$h = $this->params->get('thumb_height');
			$q = $this->params->get('thumb_quality');
			$a = $this->params->get('thumb_alignment');
			$z = $this->params->get('thumb_zoom');
			$image 	= $this->getImage($text, $title, $w, $h, $q, $a, $z);
			
			$article->introtext = $image . $article->introtext;
		}
		
		if($this->com == 'com_content' && $this->view == 'article') {
			$w = $this->params->get('thumb_articles_width');
			$h = $this->params->get('thumb_articles_height');
			$q = $this->params->get('thumb_quality');
			$a = $this->params->get('thumb_alignment');
			$z = $this->params->get('thumb_zoom');
			
			$article->text = $this->resizeAllImages($article->text, $article->title, $w, $h, $q, $a, $z);
		}		
	}
	
	
	public function getArticleDetail($id)
	{
		$query = "SELECT `introtext`, `fulltext` FROM #__content WHERE id = " . $this->db->Quote($id);
		$this->db->setQuery($query);
		$row   = $this->db->loadObject();		
		$text  = $row->introtext . $row->fulltext;
		
		return $text;
	}
	
	
	/* ZO2 Ping */
	public function onContentAfterSave($context, &$article, $isNew)
    {
    	global $mainframe, $mosConfig_sitename,$mosConfig_live_site;
    	//Get the absolute path to the site
    	$mosConfig_absolute_path = JPATH_SITE;
    	
		//Check if we are ready to ping, and then begin pinging.
		$pingUpdates = ($this->params->def('blogping_method')) ? FALSE : TRUE;
		
		if($this->_checkBeforePing($article, $pingUpdates)){
			$this->_startPings($article);
		}
		
		return true;
	}
	
	
	public function onAfterContentSave(&$article, $isNew)
	{
		//Check if we are ready to ping, and then begin pinging.
		$pingUpdates = ($this->params->def('blogping_method')) ? FALSE : TRUE;
		
		if($this->_checkBeforePing($article, $pingUpdates)) {
			$this->_startPings($article);
		}

		return true;
	}
	
	function _checkBeforePing($article, $pingOnUpdates = FALSE)
	{
		$sectionCat 	= $article->catid;
		$publicAccess 	= 1;

		// Get plugin parameters set by the user
		$blogping_enable	= $this->params->def('blogping_enable');
		$pinglist 			= $this->params->def('blogping_services');
		$pingk2array 		= (is_array($this->params->def('blogping_k2'))) ? $this->params->def('blogping_k2') : array();
		$pingcontentarray 	= (is_array($this->params->def('blogping_content'))) ? $this->params->def('blogping_content') : array();
		$pingnew 			= $this->params->def('blogping_method');

		// Check if ping not enable
		if(!$blogping_enable) {
			return FALSE;
		}
		
		//Check if pingserver is specified
		if($pinglist == "") {
			return FALSE;
		}
		
		//Article active?
		if(($article->state !=1 )) {
			return FALSE;
		}
		
		//Article published?
		$currentDate = $date = &JFactory::getDate();
		//If the article should be published in the future, then we wont ping
		if($article->publish_up > $date->toMySQL()) {
			return FALSE;
		}
		
		//Is the article only for registred users?
		if($article->access != $publicAccess) {
			return FALSE;
		}
		
		// Is com content
		if($this->com == 'com_content') {
			if(!in_array($sectionCat, $pingcontentarray)) {
				return FALSE;
			}
		}
		
		// is com k2
		if($this->com == 'com_k2') {
			if(!in_array($sectionCat, $pingk2array)) {
				return FALSE;
			}
		}		
		
		// Next check if this article is new, and if ping should be made only on new articles
		if(($pingnew == 1) && ($article->version != 1)) {			
			return FALSE;
		}
		
		return TRUE;
	}
	
	
	function _startPings($article)
	{
		//Create an array with all pingservers specified by the user.
		//First check if more than one server is specified
		
		$pinglist	= $this->params->def('blogping_services');
		$pingservers;
		$fullurl    = $this->_createUrl($article);
		
		if(substr_count($pinglist, ",")>0) {
			$pingservers = explode(",", $pinglist);
		}
		else {
			$pingservers[0] = $pinglist;
		}
		
		$urlMode 	= 'standard';
		$host 		= $_SERVER['HTTP_HOST'];
		
		//Create a full url to the article, and a message containing the title of the article.
		
		$message	= "url: " . JText::_($article->title) . "\n";
		//Get the Site name
		$app    	= JApplication::getInstance('site');
		$websiteName = JText::_($app->getCfg('sitename'));
		
		//Put together an array of the site name and the root url.
		$blogpost = array("title" => $websiteName, "postlink" => htmlentities($fullurl));
		
		//Check if pingserver is set, or show an error message
		if(count($pingservers) > 0) {
			//Go throug all the pingservers an start pinging.
			foreach($pingservers as $server)
			{
				$response	= $this->_pingServer($server, $blogpost);
			}
		}
	}
	

	function _createUrl($article)
	{
		//Variables used for changes since 1.5
		$sectionCat = $article->catid;
		
		if(!class_exists('ContentHelperRoute')) require_once (JPATH_SITE . '/components/com_content/helpers/route.php'); 
		if(!class_exists('K2HelperRoute')) 		require_once (JPATH_SITE . '/components/com_k2/helpers/route.php'); 
			
		$app    	= JApplication::getInstance('site');
		$theRouter 	= &$app->getRouter();
		
		//Create slug like  1:my-alias.html if SEF turned on, otherwise return article id
		$slug = ($app->getCfg('sef')) ? $article->id . ":" . $article->alias : $article->id;
		
		//Get SEF URL based on slug and category id
		if($this->com == 'com_content') {
			$articleLink = ContentHelperRoute::getArticleRoute($slug, $sectionCat);
		}
		
		if($this->com == 'com_k2') {
			$articleLink = K2HelperRoute::getItemRoute($article->id, $sectionCat);
		}

		$link = $theRouter->build($articleLink);
		
		//Remove administrator trash. TODO: make this remove itself
		$link = str_replace("/administrator", "", $link->toString());
		
		//Remove the irritating trailing slash that root produces
		$link = str_replace("/component/content/article", "", $link) ;
		
		
		//Make host url without the ending slash
		$hosturl = substr(JURI::root(), 0, strlen(JURI::root())-1);
		//Make sure the host is not in the current link, since well add it later.
		//This is required for some SEF-plugins that add the host.
		$link = str_replace($hosturl, "", $link);
		//Add the hosturl again
		$link = $hosturl.$link;
		
		//Decode the url to work universally
		$link = htmlentities($link);
		
		return $link;
	}
	
	function _pingServer($URL, $blogpost)
	{
		$parse 		= parse_url($URL);
		
		if(!isset($parse['host'])) return false;
		
		$host 		= $parse['host'];
		$scheme 	= $parse['scheme']."://";
		$port 		= isset($parse['port']) ? $parse['port'] : 80;
		$uri  		= isset($parse['path']) ? $parse['path'] : '/';
		
		$fp = fsockopen($host, $port, $errno, $errstr);
		
		if(!$fp) {		
			return array(-1, "Cannot open connection: $errstr ($errno)<br />\r\n");	
		}
						
		//Set methodname according to ping type
		$methodName = "weblogUpdates.ping";			

		$data = "<?xml version=\"1.0\"?>\r\n
		<methodCall>\r\n
  			<methodName>".$methodName."</methodName>\r\n
	  		<params>\r\n
	    		<param>\r\n
	      			<value><string>".$blogpost['title']."</string></value>\r\n
	    		</param>\r\n
	    		<param>\r\n
	      			<value><string>".$blogpost['postlink']."</string></value>\r\n
	    		</param>\r\n
	  		</params>\r\n
		</methodCall>";
		
		
		$len  = strlen($data);
		$out  = "POST $uri HTTP/1.0\r\n";
		$out .= "User-Agent: BlogPing 1.0\r\n";
		$out .= "Host: $host\r\n";
		$out .= "Content-Type: text/xml\r\n";
		$out .= "Content-length: $len\r\n\r\n";
		$out .= $data;
	
		fwrite($fp, $out);
		$response = '';
		while(!feof($fp)) $response .= fgets($fp, 128);
		fclose($fp);

		$lines		= explode("\r\n", $response);
		$firstline	= $lines[0];
		
		if(!ereg("HTTP/1.[01] 200 OK", $firstline))
		{	
			return array(-1, $firstline);	
		}

		while($lines[0]!='') array_shift($lines);
		array_shift($lines);
		$lines = strip_tags(implode(' ', $lines));

		$n = preg_match('|<member>\s*<name>flerror</name>\s*<value>\s*<boolean>([^<]*)</boolean>\s*</value>\s*</member>|i', $response, $matches);
		
		if(0 == $n)
		{
			return array(-1, $lines);
		}
		$flerror = $matches[1];

		$n = preg_match('|<member>\s*<name>message</name>\s*<value>\s*<string>([^<]*)</string>\s*</value>\s*</member>|i', $response, $matches);
		
		if(0 == $n)
		{
			return array(-1, $lines);
		}
		
		$message = $matches[1];
		
		return array($flerror, $message);
	}
	
	
	/* ZO2 Google Map */
	function onContentPrepare($context, &$row, &$params, $limitstart)
    {
        $param = new stdClass;
        
        $param->api_key = $this->params->get('google_map_api_key');
        $param->width   = $this->params->get('google_map_width');
        $param->height  = $this->params->get('google_map_height');
        $param->zoom    = $this->params->get('google_map_zoom');
        
        $is_mod = 1;
        
        $plugin = new Plugin_googleMaps($row, $param, $is_mod);
		
		return true;
    }
}