<?php
# Accordion Block
add_shortcode('accordion', 'accordionShortcode');
function accordionShortcode($atts, $content = null)
{	
	$accordion = "<ul class='zt-accordion'>";
	$accordion = $accordion . do_shortcode(str_replace(array("<br/>", "<br>", "<br />"), " ", $content));
	$accordion = $accordion . "</ul>";
	
	return $accordion;
}

add_shortcode('acc_item', 'accItemShortcode');
function accItemShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"title" => ''
	), $atts));
	
	$acc_item = "<li class='zt-divider'>";
	$acc_item = $acc_item . "<h3 class='accordion-head title-color zt-title'>";
	$acc_item = $acc_item . "<span class='accordion-head-image'></span>"; 
	$acc_item = $acc_item . $title . "</h3>";
	$acc_item = $acc_item . "<div class='accordion-content'>" . do_shortcode($content) . "</div>";
	$acc_item = $acc_item . "</li>";

	return $acc_item;
}


# Block Quote Block
add_shortcode('quote', 'blockquoteShortcode');
function blockquoteShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"align" => 'center', 
		'color'=>'#999999'
	), $atts));
	
	return '<div class="shortcode-block-quote-' . $align . '" style="color:' . $color . '">' . $content . '</div>';
}


# Buttons Block
add_shortcode('button', 'buttonShortcode');
function buttonShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"type"	=> '',
		"size" 	=> '',
		"state" => 'enable',
	), $atts));	
	
	
	return '<button class="btn'.
			(($type != '') ? ' btn-' . $type : '').
			(($size != '') ? ' btn-' . $size : '') .
			(($state == 'disabled') ? ' disabled' : '') .
			'">Primary</button>';
}

# Columns Block
add_shortcode('columns', 'columnsShortcode');
function columnsShortcode($atts, $content = null )
{
	return '<div class="show-grid">' . do_shortcode(str_replace(array("<br/>", "<br>", "<br />"), " ", $content)) . '</div>';	
}

# Column Block
add_shortcode('column_item', 'columnItemShortcode');
function columnItemShortcode($atts, $content = null )
{
	extract(shortcode_atts(array(
		"col" => 4,
	), $atts));
	
	return '<div class="span' . $col . '">' . $content . '</div>';
}


# Dropcap Block
add_shortcode('dropcap', 'dropcapShortcode');
function dropcapShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"type" 			=> 'circle', 
		"color" 		=> '#ffffff', 
		"background"	=> '#ef7f2c'
	), $atts));
	
	return '<div class="shortcode-dropcap ' . $type . '" style="color:'. $color .'; background-color:' . $background . ';">' . $content . '</div>';
}


# Gallery Block
$gwidth  = 100;
$gheight = 100;

add_shortcode('gallery', 'galleryShortcode');
function galleryShortcode($atts, $content = null)
{
	global $gwidth, $gheight;
	
	extract(shortcode_atts(array(
		"title" 	=> 'Photo Gallery',
		"width"		=> 100,
		"height"	=> 100,
		"columns"	=> 3
	), $atts));
	
	$gwidth  = $width;
	$gheight = $height;
	
	$gallery  = '<div class="highslide-gallery">';
	$gallery .= '<h3>' . $title . '</h3>';
	$gallery .= '<ul>' . do_shortcode(str_replace(array("<br/>", "<br>", "<br />"), " ", $content)) . '</ul>';
	$gallery .= '</div>';
	
	return $gallery;
}

add_shortcode('gallery_item', 'galleryItemShortcode');
function galleryItemShortcode($atts, $content = null)
{	
	global $gwidth, $gheight;
	
	extract(shortcode_atts(array(
		"title" => '',
		"src"	=> ''
	), $atts));
	
	$src    = (strpos($src, "http://") === false) ? JURI::base() . $src : $src;
	$simage = JURI::base() . "components/com_zo2framework/includes/timthumb.php?w=" . $gwidth . "&amp;h=" . $gheight . "&amp;src=" . $src;
	
	$gallery_item = "<li class='gallery-item'>";
	$gallery_item .= "<a title='" . $title . "' href='" . $src . "' data-rel='prettyPhoto[bkpGallery]'>";
	$gallery_item .= "<img src='" . $simage . "' title='" . $title . "' alt='" . $title . "' />";
	$gallery_item .= "</a>";
	$gallery_item .= "</li>";

	return str_replace("<br/>", " ", $gallery_item);
}


# Lightbox Block
add_shortcode('lightbox', 'lightboxShortcode');
function lightboxShortcode($atts)
{
	extract(shortcode_atts(array(
		"src"		=> '#',
		"width"		=> 'auto',
		"height"	=> 'auto',
		"title"		=> '',
		'align'		=> 'none',
		'lightbox'	=> 'on'
	), $atts));
	
	$width  = ($width  == "auto") ? "auto" : $width  . 'px';
	$height = ($height == "auto") ? "auto" : $height . 'px';

	$src   = (strpos($src, "http://") === false) ? JURI::base() . $src : $src;
	
	if($width != "auto" && $height != "auto") {
		$isrc = JURI::base() . "components/com_zo2framework/includes/timthumb.php?w=" . $width . "&amp;h=" . $height . "&amp;src=" . $src;
	}
	
	$frame = "<img src='" . $isrc . "' style='width:" . $width . "; height:" . $height . ";' alt='" . $title . "' />";

	if($lightbox == 'on') {
		$frame = "<a href='" . $src . "' class='modal' title='" . $title . "' >" . $frame . "</a>";
	}
	
	$frame = "<div class='zt-image-frame shortcode-image-" . $align . "' style='max-width: 100%; float: " . $align . "; width: " . $width . "; height: " . $height . "; '>" . $frame . "</div>";
	
	return $frame;
}


# List Block 
add_shortcode('list', 'listShortcode');
function listShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"type" => 'check'
	), $atts));
	
	return '<div class="shortcode-list shortcode-list-' . $type . '">' . $content . '</div>';
}


# Message Block
add_shortcode('message_box', 'messageBoxShortcode');
function messageBoxShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"title" =>'', 
		"color" =>'red',
		"show_close" => "No",
	), $atts));
	
	$message_box = '<div class="message-box-wrapper ' . $color . '">';
	$message_box = $message_box . '<div class="message-box-head">';
	$message_box = $message_box . '<div class="message-box-title">' . $title . '</div>';
	$message_box .= ($show_close == "Yes" || $show_close == "yes") 
				  ? '<div class="message-box-close"><a href="javascript: void(0);" onClick="closeMessage(this);">X</a></div>'
				  : "";
	$message_box = $message_box . '</div>';
	$message_box = $message_box . '<div class="message-box-content">' . $content . '</div>';
	$message_box = $message_box . '</div>';

	return $message_box;
}


# Social Block
add_shortcode('social', 'socialShortcode');
function socialShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"type" 		=> 'facebook',
		"opacity"	=> 'dark'
	), $atts));
	
	$social = '<div class="shortcode-social social-icon"><a target="_blank" title="' . $type . '" href="' . $content . '">';
	$social = $social . '<img class="no-preload" src="' . JURI::base() . 'plugins/system/shortcodes/assets/images/icon/' . $opacity . '/social/' . $type . '.png' . '" alt="' . $type . '" /></a></div>';
	
	return $social;
}


# Tabs Block
$tab_array = array();
add_shortcode('tabs', 'tabShortcode');
function tabShortcode($atts, $content = null)
{
	global $tab_array;
	$tab_array = array();
	
	do_shortcode($content);
	
	$num = count($tab_array);
	
	$tab = "<ul class='tabs'>";

	for($i = 0; $i < $num; $i ++) {
		$active = ($i == 0) ? 'active' : '';
		$tab_id = str_replace(' ', '-', $tab_array[$i]["title"]);
		
		$tab = $tab . '<li><a href="#' . $tab_id  . '" class="zt-title ';
		$tab = $tab . $active . '" >' . $tab_array[$i]["title"] . '</a></li>';
	}				
	
	$tab = $tab . "</ul>";
	$tab = $tab . "<ul class='tabs-content'>";

	for($i = 0; $i < $num; $i ++) {
		$active = ($i == 0) ? 'active' : '';
		$tab_id = str_replace(' ', '-', $tab_array[$i]["title"]);

		$tab = $tab . '<li id="' . $tab_id . '" class="';
		$tab = $tab . $active . '" >' . $tab_array[$i]["content"] . '</li>';
	}
	
	$tab = $tab . "</ul>";

	return $tab;
}
add_shortcode('tab_item', 'tabItemShortcode');
function tabItemShortcode($atts, $content = null)
{	
	extract(shortcode_atts(array(
		"title" => ''
	), $atts));
	
	global $tab_array;
	
	$tab_array[] = array("title" => $title , "content" => do_shortcode($content));
}


# Testimonial Block
add_shortcode('testimonial', 'testimonialShortcode');
function testimonialShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"author" => '',
		"position" => ''
	), $atts));
	
	$testimonial = '<div class="testimonial-content">';
	$testimonial .= '<div class="testimonial-icon"></div>';
	$testimonial .= $content;
	$testimonial .= '</div>';
	$testimonial .= '<div class="testimonial-author zt-divider">';
	$testimonial .= '<span class="testimonial-author-name">' . $author . ', </span>';
	$testimonial .= '<span class="testimonial-author-position">' . $position . '</span>';
	$testimonial .= '</div>';
	
	return $testimonial;
}


# Toggle Block
add_shortcode('toggle_box', 'toggleBoxShortcode');
function toggleBoxShortcode($atts, $content = null)
{
	$toggle_box = "<ul class='zt-toggle-box'>";
	$toggle_box = $toggle_box . do_shortcode(str_replace(array("<br/>", "<br>", "<br />"), " ", $content));
	$toggle_box = $toggle_box . "</ul>";
	
	return $toggle_box;
}
add_shortcode('toggle_item', 'toggleItemShortcode');
function toggleItemShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"title"  => ''
	), $atts));
	
	$toggle_item = "<li class='zt-divider'>";
	$toggle_item = $toggle_item . "<h3 class='toggle-box-head title-color zt-title'>";
	$toggle_item = $toggle_item . "<span class='toggle-box-head-image'></span>"; 
	$toggle_item = $toggle_item . $title . "</h3>";
	$toggle_item = $toggle_item . "<div class='toggle-box-content'>" . do_shortcode($content) . "</div>";
	$toggle_item = $toggle_item . "</li>";

	return $toggle_item;
}


# Vimeo Block
add_shortcode('vimeo', 'vimeoShortcode');
function vimeoShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"height" => '300', 
		"width"  => '400'
	), $atts));

	preg_match('/http:\/\/vimeo.com\/(\d+)$/', $content, $id);
	
	$vimeo = '<div class="zo2-vimeo" style="max-width:' . $width . 'px;" >';
	$vimeo = $vimeo . '<iframe src="http://player.vimeo.com/video/' . $id[1] . '?title=0&amp;byline=0&amp;portrait=0" width="' . $width . '" height="' . $height . '" ></iframe>';
	$vimeo = $vimeo . '</div>';
	
	return $vimeo;
}


# Youtube
add_shortcode('youtube', 'youtubeShortcode');
function youtubeShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"height" => '400',
		"width"  => '300'
	), $atts));
	
	preg_match('/[\\?\\&]v=([^\\?\\&]+)/', $content, $id);
	
	$youtube = '<div class="zo2-youtube" style="max-width:' . $width . 'px;" >';
	$youtube = $youtube . '<iframe src="http://www.youtube.com/embed/' . $id[1] . '?wmode=transparent" width="' . $width . '" height="' . $height . '"></iframe>';
	$youtube = $youtube . '</div>';
	
	return $youtube;
}


# Divider
add_shortcode('divider', 'dividerShortcode');
function dividerShortcode($atts, $content = null)
{
	extract(shortcode_atts(array(
		"scroll_text" => ''
	), $atts));	

	$divider = '<div class="divider"><div class="scroll-top">';	
	$divider = $divider . $scroll_text . '</div></div>';
		
	return $divider;
}


# Space
add_shortcode('space', 'spaceShortcode');
function spaceShortcode($atts)
{
	extract(shortcode_atts(array(
		"height" => '20'
	), $atts));	
	
	return "<div style='clear:both; height:" . $height . "px;' ></div>";
}


# SyntaxHighlighter
add_shortcode('highlighter', 'highlighterShortcode');
function highlighterShortcode($atts, $content)
{	
	$text    = '';
	$script  = '';
	
	if(!defined('ZO2_HIGHLIGHT_CODE')) {
		$script = '<script type="text/javascript">$ZO2(document).ready(function() {prettyPrint();});</script>';
		define('ZO2_HIGHLIGHT_CODE', 1);
	}
	 
	extract(shortcode_atts(array(
			"lang"		=> '',
			"linenums" 	=> 'true',
			"startnums" => 0
	), $atts));
    
	$text = '<pre class="prettyprint'.(($lang != '') ? ' lang-' . $lang : '').(($linenums == 'true') ? ' linenums' : '')
		  . (($startnums && $linenums == 'true') ? ':' . $startnums : '').'">'
		  . $content
		  . '</pre>'
		  . $script;
        
	return $text;
}


# Pricing Tables
$pcolumns = 3;
add_shortcode('pricing', 'pricingShortcode');
function pricingShortcode($atts, $content = null )
{
	global $pcolumns;
	
	extract(shortcode_atts(array(
		"columns" 			=> '3',
	), $atts));
	
	$pcolumns	= $columns;
	$class 		= 'pricing_wrap_' . $columns;
	
	return '<div class="'.$class.'">' . do_shortcode(str_replace(array("<br/>", "<br>", "<br />"), " ", $content)) . '</div>';
}


# Pricing Tables
add_shortcode('plan', 'planLineShortcode');
function planLineShortcode($atts, $content = null )
{
	global $pcolumns;
	
	extract(shortcode_atts(array(
		"title" 		=> '',
		"button_link" 	=> '',
		"button_label" 	=> '',
		"price" 		=> '',
		"featured" 		=> '',
		"per"			=> 'month',
	), $atts));
	
	return  '<div class="pricing_box plan1-' . $pcolumns . (('true' == strtolower($featured)) ? ' featured' : '') . '">' . 
				'<div class="header"><span>' . $title . '</span></div>' . 
				'<h2>' . $price . '<span style="font-size: 14px;">/' . $per . '</span></h2>' . 
				do_shortcode(str_replace(array("<br/>", "<br>", "<br />"), " ", $content)) . 
				'<a class="button" href="' . $button_link . '">' . $button_label . '</a>' .
			 '</div>';
}
