<?php
/**
 * @package Shortcodes for Joomla! 2.5
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2010- ZooTemplate.com
 * @license PHP files are GNU/GPL
**/

defined('_JEXEC') or die('Restricted access');

// Import Joomla core library
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');
jimport('joomla.plugin.plugin');

// Require common functions
require_once dirname(__FILE__) . "/assets/includes/common.php";
// Include all shortcode
include_once dirname(__FILE__) . "/assets/includes/allshortcodes.php";

class plgSystemShortcodes extends JPlugin
{		
	var $document = NULL;
	var $baseurl  = NULL;
	
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		
		$this->document = JFactory::getDocument();
		$this->baseurl = str_replace("/administrator", "", JURI::base());
	}
	
	// Function on after render
	public function onAfterRender()
	{
		$runmode = $this->params->get('runmode', 0);				
		$app 	 = JFactory::getApplication();
		
		// Only enable shortcodes in fontend & work with buffer of page
		if($app->isSite())
		{
			if($runmode == 1) {
				$page = JResponse::GetBody();
				$page = do_shortcode($page);
				JResponse::SetBody($page);
			}
		}
		
		// Add shortcodes button into editor
		$this->addShortCodes();
	}	
	
	// Enable shortcodes in Articles content
	public function onContentPrepare($context, &$article, &$params, $page=0)
	{
		$runmode = $this->params->get('runmode', 0);
		
		if($runmode != 0) return;
		$article->text = do_shortcode($article->text);
		
		return true;
	}
	
	// Add media
	public function onBeforeRender()
	{
		$app = JFactory::getApplication();
		
		$this->document->addStyleSheet($this->baseurl . "plugins/system/shortcodes/assets/css/shortcodes.css");
		if($app->isSite())
		{
			$this->document->addScript($this->baseurl . "plugins/system/shortcodes/assets/js/shortcodes.js");
		}
	}	
	
	// Function add shortcodes button into editor
	public function addShortCodes()
	{
		$page   = JResponse::GetBody();
		
		$button = $this->getShortCodes();
		$stext  = '<script type="text/javascript">
						function jSelectShortcode(text) {
							text = text.replace(/\'/g, \'"\');
							if(document.getElementById(\'jform_articletext\') != null) {
								jInsertEditorText(text, \'jform_articletext\');
							}
							if(document.getElementById(\'text\') != null) {
								jInsertEditorText(text, \'text\');
							}
							if(document.getElementById(\'jform_description\') != null) {
								jInsertEditorText(text, \'jform_description\');
							}
							if(document.getElementById(\'jform_content\') != null) {
								jInsertEditorText(text, \'jform_content\');
							}
							SqueezeBox.close();  
						}
				   </script>';
		
		$page = str_replace('<div id="editor-xtd-buttons">', '<div id="editor-xtd-buttons">' . $button . '<div class="shortcode-clear"></div>', $page);
		$page = str_replace('</body>', $stext . '</body>', $page);
		
		JResponse::SetBody($page);
	}
	
	// Build shorcodes list
	public function getShortCodes()
	{
		$shortcoders = array(
			'accordion' => array(
				'name'		=> "Accordion",
				'desc'		=> "Accordion",
				'syntax'	=> "[accordion]<br/>[acc_item title=\'ITEM_TITLE\']ADD_CONTENT_HERE[/acc_item]<br/>[acc_item title=\'ITEM_TITLE\']ADD_CONTENT_HERE[/acc_item]<br/>[acc_item title=\'ITEM_TITLE\']ADD_CONTENT_HERE[/acc_item]<br/>[/accordion]<br/>",
				'image'		=> "accordion.png"
			),
			'blockquote' => array(
				'name'		=> "Blockquote",
				'desc'		=> "Blockquote",
				'syntax'	=> "[quote align=\'center\' color=\'#999999\']ADD_CONTENT_HERE[/quote]",
				'image'		=> "blockquote.png"
			),
			'buttons' => array(
				'name'		=> "Buttons",
				'desc'		=> "Buttons",
				'syntax'	=> "[button type=\'primary\' size=\'large\' state=\'enable\']ADD_BUTTON_CONTENT[/button]",
				'image'		=> "buttons.png"
			),
			'column' => array(
				'name'		=> "Column",
				'desc'		=> "Column",
				'syntax'	=> "[columns]<br/>[column_item col=\'4\']ADD_CONTENT_HERE[/column_item]<br/>[column_item col=\'4\']ADD_CONTENT_HERE[/column_item]<br/>[column_item col=\'4\']ADD_CONTENT_HERE[/column_item]<br/>[/columns]",
				'image'		=> "column.png"
			),
			'dropcap' => array(
				'name'		=> "Dropcap",
				'desc'		=> "Dropcap",
				'syntax'	=> "[dropcap type=\'circle\' color=\'#COLOR_CODE\' background=\'#COLOR_CODE\']ADD_CONTENT_HERE[/dropcap]",
				'image'		=> "dropcap.png"
			),
			'gallery' => array(
				'name'		=> "Gallery",
				'desc'		=> "Gallery",
				'syntax'	=> "[gallery title=\'GALLERY_TITLE\' width=\'IMAGE_THUMB_WIDTH\' height=\'IMAGE_THUMB_HEIGHT\' columns=\'3\']<br/>[gallery_item title=\'IMAGE_TITLE\' src=\'IMAGE_SRC\']IMAGE_DESCRIPTION[/gallery_item]<br/>[gallery_item title=\'IMAGE_TITLE\' src=\'IMAGE_SRC\']IMAGE_DESCRIPTION[/gallery_item]<br/>[gallery_item title=\'IMAGE_TITLE\' src=\'IMAGE_SRC\']IMAGE_DESCRIPTION[/gallery_item]<br/>[/gallery]",
				'image'		=> "gallery.png"
			),
			'lightbox' => array(
				'name'		=> "Lightbox",
				'desc'		=> "Lightbox",
				'syntax'	=> "[lightbox src=\'IMAGE_SRC\' width=\'IMAGE_WIDTH\' height=\'IMAGE_HEIGHT\' lightbox=\'on\' title=\'IMAGE_TITLE\' align=\'left\']",
				'image'		=> "lightbox.png"
			),
			'list' => array(
				'name'		=> "List Style",
				'desc'		=> "List Style",
				'syntax'	=> "[list type=\'check\']<br/><ul><li>ADD_LIST_CONTENT</li>\<li>ADD_LIST_CONTENT</li></ul>[/list]",
				'image'		=> "list.png"
			),
			'message' => array(
				'name'		=> "Message Boxes",
				'desc'		=> "Message Boxes",
				'syntax'	=> "[message_box title=\'MESSAGE_TITLE\' color=\'red\' show_close=\'Yes/No\']ADD_CONTENT_HERE[/message_box]",
				'image'		=> "message.png"
			),
			'social' => array(
				'name'		=> "Social Icons",
				'desc'		=> "Social Icons",
				'syntax'	=> "[social type=\'facebook\' opacity=\'dark\']PLACE_LINK_HERE[/social]",
				'image'		=> "social.png"
			),
			'tabs' => array(
				'name'		=> "Tabs",
				'desc'		=> "Tabs",
				'syntax'	=> "[tabs]<br/>[tab_item title=\'ITEM_TITLE\']ADD_CONTENT_HERE[/tab_item]<br/>[tab_item title=\'ITEM_TITLE\']ADD_CONTENT_HERE[/tab_item]<br/>[tab_item title=\'ITEM_TITLE\']ADD_CONTENT_HERE[/tab_item]<br/>[/tabs]",
				'image'		=> "tabs.png"
			),
			'testimonial' => array(
				'name'		=> "Testimonial",
				'desc'		=> "Testimonial",
				'syntax'	=> "[testimonial author=\'TESTIMONIAL_AUTHOR\' position=\'AUTHOR_POSITION\']ADD_TESTIMONIAL_HERE[/testimonial]",
				'image'		=> "testimonial.png"
			),
			'toggle' => array(
				'name'		=> "Toggle Boxes",
				'desc'		=> "Toggle Boxes",
				'syntax'	=> "[toggle_box]<br/>[toggle_item title=\'ITEM_TITLE\']ADD_CONTENT_HERE[/toggle_item]<br/>[toggle_item title=\'ITEM_TITLE\' active=\'true\']ADD_CONTENT_HERE[/toggle_item]<br/>[/toggle_box]",
				'image'		=> "toggle.png"
			),
			'vimeo' => array(
				'name'		=> "Vimeo",
				'desc'		=> "Vimeo",
				'syntax'	=> "[vimeo height=\'HEIGHT\' width=\'WIDTH\']PLACE_LINK_HERE[/vimeo]",
				'image'		=> "vimeo.png"
			),
			'youtube' => array(
				'name'		=> "Youtube",
				'desc'		=> "Youtube",
				'syntax'	=> "[youtube height=\'HEIGHT\' width=\'WIDTH\']PLACE_LINK_HERE[/youtube]",
				'image'		=> "youtube.png"
			),
			'divider' => array(
				'name'		=> "Divider",
				'desc'		=> "Divider",
				'syntax'	=> "[divider scroll_text=\'SCROLL_TEXT\']<br/>",
				'image'		=> "divider.png"
			),
			'spacer' => array(
				'name'		=> "Add Space",
				'desc'		=> "Add Space",
				'syntax'	=> "[space height=\'HEIGHT\']<br/>",
				'image'		=> "space.png"
			),
			'highlighter' => array(
				'name'		=> "Syntax Highlighting",
				'desc'		=> "Syntax highlighting of code snippets in a web page",
				'syntax'	=> "[highlighter lang=\'js\' linenums=\'true\' startnums=\'1\']YOUR_CODE_HERE[/highlighter]<br/>",
				'image'		=> "highlighter.png"
			),
			'googlemap' => array(
				'name'		=> "Google Map",
				'desc'		=> "Google Map",
				'syntax'	=> "[googleMaps addr=\'ADDRESS OR Latitude/Longitude\' label=\'GOOLE_MAP_LABEL\' width=400 height=400]<br/>",
				'image'		=> "google_map.png"
			),
			'pricing' => array(
				'name'		=> "Pricing Tables",
				'desc'		=> "Pricing Tables",
				'syntax'	=> "[pricing columns=\'3\']<br/>[plan title=\'PRICING_TITLE\' button_link=\'http://\' button_label=\'PRICING_BUTTON_LABEL\' price=\'$200\' featured=\'false\' per=\'month\']TEXT_OF_PLAN[/plan]<br/>[plan title=\'PRICING_TITLE\' button_link=\'http://\' button_label=\'PRICING_BUTTON_LABEL\' price=\'$200\' featured=\'false\' per=\'month\']TEXT_OF_PLAN[/plan]<br/>[plan title=\'PRICING_TITLE\' button_link=\'http://\' button_label=\'PRICING_BUTTON_LABEL\' price=\'$200\' featured=\'false\' per=\'month\']TEXT_OF_PLAN[/plan]<br/>[/pricing]<br/>",
				'image'		=> "pricing.png"
			),
		);
		
		$text  = '';
		if(count($shortcoders))
		foreach($shortcoders as $key => $shortcoder) {
			$text .= '<div class="button2-left">';
				$text .= '<div class="bsc-'.$key.'">';
					$text .= '<a class="pointer" href="javascript: void(0);" onclick="jSelectShortcode(\'' . $shortcoder['syntax'] . '\')" title="' . $shortcoder['desc'] . '">';
						$text .= $shortcoder['name'];
					$text .= '</a>';
				$text .= '</div>';
			$text .= '</div>';	
		}
		
		return $text;
	}
}